/*Rozwiazanie zadan z bibliotek obie grupy z egz ON czerwiec 2007
 - przy pomocy dgesv obliczyc macierz odwrotna
a na stepnie pomnozyc macierz wyjsciowa przez odwrotna i sprawdzic czy wyszla Id!
a w drugim roziwazac LZNK z wieloma prawymi stronami ktore tworza macierz
identycznosci w glownym minorze
******************************************************************************/

#include<stdio.h>
#include<stdlib.h>


/*prototypy*/
void dgesv_(int *N,int * NRHS,double *A,int * LDA,int * IPIV,
				double *B,int * LDB, int *INFO );
void dgemm_(char *TRANSA,char *TRANSB,int *M,int *N,int *K,
		double *ALPHA,double *A,int *LDA,
	double *B,int *LDB,double *BETA,double *C,int *LDC);

void dgelsy_(int *M,int *N,int *NRHS,double *A,int  *LDA,double *B,int *LDB,
		int *JPVT,double *RCOND,int  *RANK,
		double *WORK,int *LWORK, int *INFO);


int invA(int N,double *A,double *Amo);
int invLLSE(int M,int N,double *A,double *Amo);

int main(void)
{
  double *A,*B,*C;
  double ALPHA=1.0,BETA=0.0;
  char TRANSA='n',TRANSB='n';
  int info=0, N=2, M=N, K=N, LDB=N, LDA=N, LDC=N;
  A=(double *)malloc(N*N*sizeof(*A));
  B=(double *)malloc(N*N*sizeof(*B));
  C=(double *)malloc(N*N*sizeof(*C));
  
  int *JPVT,LWORK=-1, RANK=0,NRHS=1,INFO;
  double *WORK,RCOND=1;
  
  A[0]=2; A[2]=3.0;
  A[1]=1.0; A[3]=4.0;
  
  B[0]=B[1]=B[2]=B[3]=-21.34567;
  
  /*funkcja invA - oblicza macierz odwrotna do A i umieszcza ja w  B
*/  
  info=invA(N,A,B);
  
  
  A[0]=2; A[2]=3.0;
  A[1]=1.0; A[3]=4.0;
  dgemm_(&TRANSA,&TRANSB,&M,&N,&K,&ALPHA,A,&LDA,B,&LDB,&BETA,C,&LDC);
  printf("macierz odwrotna:\n %g %g \n %g %g\n",B[0],B[2],B[1],B[3]);
  printf("macierz Id:\n %g %g \n %g %g\n",C[0],C[2],C[1],C[3]);
  if(info==0) printf("invA dziala!\n");
  else printf("Zawiodlo dgesv  info-%d\n",info);
  free(A);free(B);free(C);
  
  
  /*druga grupa
  ****************************************************/
  N=2;M=3;NRHS=N; LDA=LDB=M;
  A=(double *)malloc(M*N*sizeof(*A));
  B=(double *)malloc(M*NRHS*sizeof(*B));
  A[0]=1;  A[3]=3;
  A[1]=-1; A[4]=0;
  A[2]=0;  A[5]=2;
  
  B[0]=B[1]=B[2]=B[3]=B[4]=B[5]=12.345; 
  
    
  INFO=invLLSE(M,N,A,B); 
  if(INFO==0)
   printf("Gr II LZNK Sukces! \n");
  else printf("Porazka! INFO=%d\n",INFO);
   
  printf("X rozw=\n%g %g\n%g %g\n",B[0],B[3],B[1],B[4]);
  free(A);free(B);
return 1;
}

/********************************************
Zad z bibliotek gr II o 1030 czer 2007
oblicza rozwiazanie LZNK z prawa strona macierz B
Rzowiazanie w B
zwraca INFO z dgelsy()
*********************************************/
int invLLSE(int M,int N,double *A,double *B)
{
  int *JPVT,RANK=0,LWORK=-1;
  double *WORK,RCOND=0;
  int INFO=0,NRHS=N,LDB=M,LDA=M;

  int k,l;

  JPVT=(int *)malloc(N*sizeof(int));
  
  for(k=0;k<M*N;k++)
   B[k]=0.0;
   
  for(k=0;k<N;k++)
   B[k+k*M]=1.0;
  /*Testujemy wymiar WORKSPACE */
  WORK=(double*)malloc(sizeof(double));
  LWORK=-1;
  dgelsy_(&M,&N,&NRHS,A,&LDA,B,&LDB,
		JPVT,&RCOND,&RANK,
		WORK,&LWORK,&INFO);
  LWORK=WORK[0];
  printf("Rozmiar WORKSPACE:  LWORK=%d\n",LWORK);
  free(WORK);

  RCOND=0;
  WORK=(double*)malloc(LWORK*sizeof(double));
  dgelsy_(&M,&N,&NRHS,A,&LDA,B,&LDB,
		JPVT,&RCOND,&RANK,
		WORK,&LWORK,&INFO);  
  
  free(WORK);
  free(JPVT);
  
  return INFO;
}


/******************************************************
 Funkcja oblicza A^{-1} i umieszcza ja w B a w A jest rozklad
 LU macierzy A - czyli A sie zmienia
 zwraca INFO z dgesv
*******************************************************/
int invA(int N,double *A,double *Amo)
{
  int *ipiv;
  int info=0,NRHS=N,LDB=N,LDA=N;
  int k,l;
  double *B=Amo;
  ipiv=(int *)malloc(N*sizeof(int));
  
  for(k=0;k<N*N;k++)
   Amo[k]=0.0;
   
  for(k=0;k<N;k++)
   Amo[k+k*N]=1.0;
  
  dgesv_(&N,&NRHS,A,&LDA,ipiv,Amo,&LDB,&info);
  if(info!=0) printf("invA: dgesv zawodzi nie mozna policzyc macierzy odwrotnej!");
  free(ipiv);
  
  return info;
}
